%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Authors: A. Ali and T. Y. Al-Naffouri                                           
% Last Modified: June, 2016
%
% If you use this code or any (modified) part of it in any publication, please cite 
% the paper: A. Ali, M. Masood, M. S. Sohail, S. Al-Ghadhban, and T. Y. Al-Naffouri, Narrowband Interference Mitigation in SC-FDMA Using Bayesian Sparse Recovery, IEEE Transactions on Signal Processing.
%
% Copyright (c) A. Ali, M. Masood, M. S. Sohail, S. Al-Ghadhban, and T. Y. Al-Naffouri
%
% Contact Persons: A. Ali and T. Y. Al-Naffouri
% E-mail: anumali@utexas.edu, tareq.alnaffouri@kaust.edu.sa
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Figure 2
load('Figure_2.mat')
figure,semilogy(EbNo_dB,BER(1,:),'gs-'),hold on;
semilogy(EbNo_dB,BER(2,:),'bd-');
semilogy(EbNo_dB,BER(3,:),'ro-');
semilogy(EbNo_dB,BER(4,:),'go-');
semilogy(EbNo_dB,BER(5,:),'mx-');
semilogy(EbNo_dB,BER(6,:),'kp-');
legend('NBI Free','NBI Impaired','Proposed','l1-optimization','FISTA','SBL');
xlabel('Eb/N0'),ylabel('BER')
%
figure,semilogy(EbNo_dB,RT(1,:),'ro-');
hold on, semilogy(EbNo_dB,RT(2,:),'go-');
hold on, semilogy(EbNo_dB,RT(3,:),'mx-');
hold on, semilogy(EbNo_dB,RT(4,:),'kp-');
legend('Proposed','l1-optimization','FISTA','SBL');
%% Figure 3
load('Figure_3.mat')
BER(1,:)=mean(BER(1,:))*ones(1,length(TS_vec));
BER(2,:)=mean(BER(2,:))*ones(1,length(TS_vec));
%
figure,semilogy(TS_vec,BER(1,:),'gs-'),hold on;
semilogy(TS_vec,BER(2,:),'bd-');
semilogy(TS_vec,BER(3,:),'ro-');
semilogy(TS_vec,BER(4,:),'go-');
semilogy(TS_vec,BER(5,:),'mx-');
semilogy(TS_vec,BER(6,:),'kp-');
legend('NBI Free','NBI Impaired','Proposed','l1-optimization','FISTA','SBL');
xlabel('No of Reserved Tones'),ylabel('BER')
%
figure,semilogy(TS_vec,RT(1,:),'ro-');
hold on, semilogy(TS_vec,RT(2,:),'go-');
hold on, semilogy(TS_vec,RT(3,:),'mx-');
hold on, semilogy(TS_vec,RT(4,:),'kp-');
legend('Proposed','l1-optimization','FISTA','SBL');
xlabel('No of Reserved Tones'),ylabel('RT')
%% Figure 4
load('Figure_4.mat')
BER(1,:)=mean(BER(1,:))*ones(1,length(p_vec));
BER(2,:)=mean(BER(2,:))*ones(1,length(p_vec));
%
figure,semilogy(p_vec,BER(1,:),'gs-'),hold on;
semilogy(p_vec,BER(2,:),'bd-');
semilogy(p_vec,BER(3,:),'ro-');
legend('NBI Free','NBI Impaired','Proposed');
xlabel('Eb/N0'),ylabel('BER')
%% Figure 5
load('Figure_5.mat')
figure,plot(1:max_no_NBI,sparsity_true_vec,'ro-');
hold on,plot(1:max_no_NBI,sparsity_spd_vec,'go-');
hold on,plot(1:max_no_NBI,sparsity_haar_vec,'mx-');
hold on,plot(1:max_no_NBI,sparsity_window_vec,'kp-');
%
legend('Original Signal (Perfect Alignment)','Spread Signal',...
    'Haar Transform Sparsification','Window Sparsification');
xlabel('No of NBI sources'),ylabel('Gini Index')
%% Figure 6
load('Figure_6.mat')
figure,semilogy(EbNo_dB,BER(1,:),'ro-'),hold on;
semilogy(EbNo_dB,BER(2,:),'go-');
semilogy(EbNo_dB,BER(3,:),'mx-');
semilogy(EbNo_dB,BER(4,:),'kp-');
semilogy(EbNo_dB,BER(5,:),'rd-');
semilogy(EbNo_dB,BER(6,:),'bx-');
legend('NBI Free','NBI Impaired','Spread','Haar','Window','l1-optimization');
%% Figure 7
load('Figure_7.mat')
BER(1,:)=mean(BER(1,:))*ones(1,length(TS_vec));
BER(2,:)=mean(BER(2,:))*ones(1,length(TS_vec));
%
figure,semilogy(TS_vec,BER(1,:),'ro-'),hold on;
semilogy(TS_vec,BER(2,:),'go-');
semilogy(TS_vec,BER(3,:),'mx-');
semilogy(TS_vec,BER(4,:),'kp-');
semilogy(TS_vec,BER(5,:),'rd-');
semilogy(TS_vec,BER(6,:),'bx-');
legend('NBI Free','NBI Impaired','Spread','Haar','Window','l1-optimization');
%% Figure 8
load('Figure_8.mat')
figure,semilogy(EbNo_dB,BER(1,:),'gs-'),hold on;
semilogy(EbNo_dB,BER(2,:),'bd-');
semilogy(EbNo_dB,BER(3,:),'ro-');
legend('ZF-FDE','MMSE-FDE','ZF-FDE (Noise-cancellation)');
xlabel('Eb/N0'),ylabel('BER')
%% Figure 10
load('Figure_10.mat')
figure,semilogy(EbNo_dB,BER(1,:),'ro-'),hold on;
semilogy(EbNo_dB,BER(2,:),'go-');
semilogy(EbNo_dB,BER(3,:),'mx-');
semilogy(EbNo_dB,BER(4,:),'kp-');
legend('NBI Free','NBI Impaired','Recovered','Augmented Recovered')
%% Figure 11
load('Figure_11.mat')
figure,semilogy(EbNo_dB,BER(1,:),'ro-'),hold on;
semilogy(EbNo_dB,BER(2,:),'go-');
semilogy(EbNo_dB,BER(3,:),'mx-');
semilogy(EbNo_dB,BER(4,:),'kp-');
legend('NBI Free','NBI Impaired','Recovered','Augmented Recovered')
%% Figure 13
load('Figure_13.mat')
figure,semilogy(EbNo_dB,BER(1,:),'gs-'),hold on;
semilogy(EbNo_dB,BER(2,:),'kd-');
semilogy(EbNo_dB,BER(3,:),'bo-');
semilogy(EbNo_dB,BER(4,:),'r^-');
legend('NBI Free','NBI Impaired','SMV-Recovered','MMV-Recovered');
xlabel('E_b/N_0');ylabel('BER');