function [h,h_cap,H,D]=channel_make(L,N,FN,FHN)
% channel_make create a channel.
% Inputs:
% L: The length of the channel
% N: The length of the SC-FDMA symbol
% FN: The Fourier matrix of dimension N
% FHN: The inverse Fourier matrix of dimension N
%
% Outputs:
% h: The channel impulse response
% h_cap: The channel frequency response
% H: Circulant time domain channel matrix
% D: Diagonal frequency domain channel matrix
%
%   Authors : A. Ali and T. Y. Al-Naffouri

j=sqrt(-1);
if(L==0)
    h=1;
    h_cap=sqrt(N)*FN*[h;zeros(N-1,1)];
else
    h=sqrt(1/2)*(randn(L,1)+j*randn(L,1));
    h_cap=sqrt(N)*FN*[h;zeros(N-L,1)];
end
D=diag(h_cap);
H=FHN*D*FN;